#include <Adafruit_GFX.h>
#include "Adafruit_LEDBackpack.h"

int SPEAKER = 3;
int UP = 4;
int DOWN = 2;
int PLAY = 7;

Adafruit_8x8matrix matrix = Adafruit_8x8matrix();

int tones[] = {3,3,3,3,3,3,3,3};
int freqs[] = {261, 294, 329, 349, 392, 440, 493, 523};
//frequencies for c,d,e,f,g,a,b,C (found online)

uint8_t notes_bmp[] = 
{ B00001000,
  B00001000,
  B00001000,
  B00001000,
  B00001000,
  B00001000,
  B00001000,
  B00001000 };

void setup() {
  matrix.begin(0x70);
  Serial.begin(9600);
  pinMode(SPEAKER, OUTPUT);
  pinMode(UP, INPUT);
  pinMode(DOWN, INPUT);
  pinMode(PLAY, INPUT);
}

void loop() {
  changeNotes();
  draw();  
  play();
}

void play() { 
  if(digitalRead(PLAY) == HIGH) {
    for(int i = 7; i > -1; i--)
    {
      Serial.println("asdf");
      uint8_t saved = notes_bmp[i];
      notes_bmp[i] = B11111111;
      draw();
      tone(SPEAKER, freqs[tones[i]], 300);
      delay(300);

      notes_bmp[i] = saved;
      draw();
      delay(50);
    }
    
  }
}

void changeNotes() {
  int currentCol = getCurrentCol();  
  if(digitalRead(DOWN) == HIGH) {
    if(tones[currentCol] > 0) {
      notes_bmp[currentCol] = notes_bmp[currentCol] >> 1;
      delay(250);
      tones[currentCol] -= 1;
    }    
  }
  else if(digitalRead(UP) == HIGH) {
    if(tones[currentCol] < 7) {
      notes_bmp[currentCol] = notes_bmp[currentCol] << 1;
      delay(250);
      tones[currentCol] += 1;
    }
  }
}

int getCurrentCol() {
  int sliderVal = analogRead(A0);
  return (int)(sliderVal/140);
}

void draw() {
  matrix.clear();
  matrix.drawBitmap(0, 0, notes_bmp, 8, 8, LED_ON);
  matrix.writeDisplay();
}

